var list_users = "";
var list_accounts = "";

// load list units 
function init_accounts() {
	// flags to specify what kind of data should be returned
	var flags = wialon.item.Item.dataFlag.base | wialon.item.Item.dataFlag.billingProps | wialon.item.Item.dataFlag.customProps;
	session.loadLibrary("resourceAccounts"); // load Accounts Library
	session.updateDataFlags( // load items to current session
		[{type: "type", data: "avl_resource", flags: flags, mode: 0}], // Items specification
	function (code) { // updateDataFlags callback
		if (code) { msg(wialon.core.Errors.getErrorText(code)); return; } // exit if error code
		list_accounts = session.getItems("avl_resource"); // get loaded 'avl_resource' items
		if (!list_accounts || !list_accounts.length){ alert("No resources found"); return; } // check if resources found
		
		init_users();
	});
}

// load list units 
function init_users() {
    
	// get list uers
	var dataFlags = wialon.item.Item.dataFlag.base | wialon.item.Item.dataFlag.customProps  | wialon.item.User.dataFlag.connSettings | wialon.item.User.dataFlag.flags |wialon.item.Item.accessFlag.editOther ;
	var spec = [{type: "type", data: "user", flags: dataFlags, mode: 0}];		
	session.updateDataFlags(spec, function(code) {
		if (code) { msg(wialon.core.Errors.getErrorText(code)); return; }
		list_users = session.getItems("user");		
		
		jQuery("#td_users").html('<b>Выберите пользователя:</b><BR><select id="list_users" size="30" style="width: 200px;" onChange="init_units();"></select><BR><b>Импорт сообщений, дней.: </b> <input type="text" id="count_day" value="400" style="width:200px;"/>');
		
		var ind = 1;
		for (var i = 0; i < list_users.length; i++) {
			
			var user = list_users[i];	
			if (user.getName() == curr_user_session.getName())
				continue;
			
			jQuery("#list_users").append("<option value='" + user.getId() + "'>" + user.getName() + "</option>");
			
		}
				
		
		jQuery("#list_units").html("");
    		
	});
	
	
}
var result_unit = "";
function init_units() {

	jQuery("#list_units").html("<img src='img/Loading.gif'>");
	var select_user = $("#list_users").val();
	for (var i = 0; i < list_users.length; i++) {
		var user = list_users[i];	
		if (user.getId() == select_user) {
			user.getItemsAccess(true, "avl_unit", function(code,result) {
				result_unit = result;
				if (code) { alert(wialon.core.Errors.getErrorText(code)); return; }
				var html = "<b>Выберите объект:</b><table cellpadding='7'><tr><td>№</td><td></td><td><b>Объект</b></td><td><b>Аккаунт</b></td><td><b>Создатель</b></td></tr>";
				var i = 1;
				for(var unit_id in result) {
					var unit = get_unit_by_id(unit_id);
					
					html += "<tr><td>" + i + "</td><td> <input type='checkbox' id='check_unit_" + unit.getId() + "'/></td><td>" + unit.getName() + "</td><td>" + get_account_by_id(unit.getAccountId()).getName() + "</td><td>" + get_user_by_id(unit.getCreatorId()).getName() + "</td></tr>";
					i++;
		 
				}
				html += "</table>";
				
				html += "<BR><BR><input type='button' onClick=\"index = -1; active_user_id= '" + $("#list_users").val() + "'; switch_creator_unit();\" value='Пересоздать от имени пользователя " + get_user_by_id($("#list_users").val()).getName() + "'/>";
				
				if (i > 1)				
					jQuery("#list_units").html(html);
				else
					jQuery("#list_units").html("<BR><BR><b>У выбранного пользователя нет доступных ему объектов</b>");
		
			});	
		
			break;
		}
	}	
}

var index = -1;
var active_user_id = 0;
var active_unit = 0;

function switch_creator_unit() {
	
	var count_day = $("#count_day").val();
	
	if (index == -1)
		$("#td_log").html("После создания копии объектов не забудьте перезапустить приложение!<BR><BR>");
	
	var local_index = -1;
	for(var unit_id in result_unit) {
		
		local_index++;
		
		if (local_index <= index)
			continue;
		
		var unit = get_unit_by_id(unit_id);
		if($("#check_unit_" + unit.getId()).prop("checked")) {

			active_unit = unit;
			index = local_index;
			
			$("#td_log").append("<BR>Началось создание объекта " + unit.getName() + ", пожалуйста подождите");
					
			session.createAuthHash(function(code, hash) {
				$.ajax({
					url: 'ajax/recreate_unit.php',
					data: "unit_id=" + active_unit.getId() + "&new_creator=" + active_user_id + "&hash=" + hash.authHash + "&login=" + curr_user_session.getName() + "&count_day=" + count_day,
					success: function(data) {
						$("#td_log").append(data);
						
						switch_creator_unit();
					}
				});	
			});			
			return;
		}	
	}	
}

function get_user_by_id(id) {
	// load list cmd
	for (var i = 0; i < list_users.length; i++) {
		var user = list_users[i];
		var user_id = user.getId();
		
		if (id == user_id) 
			return user;
	}
	return "NULL";
	
}

function get_account_by_id(id) {
	// load list cmd
	for (var i = 0; i < list_accounts.length; i++) {
		var account = list_accounts[i];
		var account_id = account.getId();
		
		if (id == account_id) 
			return account;
	}
	return "NULL";
}
